{% macro view(query, placeholder) %}

    <form class="search" action="" method="get" id="search-form">
        <span id="clear-icon" style="position: absolute; display: none; z-index: 999; "><i class="fa fa-times-circle" style="font-size: 170%; margin: 0.2em 0.3em; color: #66afe9; cursor: pointer;"></i></span>
        <i class="fa fa-search fa-fw" id="search-icon" style="font-size: 150%;  margin: 0.3em 0.2em; color: silver; position: absolute; z-index: 999"></i>
        <div class="input-group">
            <input style="padding-left: 2.5em;" id="search" name="query" value="{{ query }}" type="text" class="form-control" placeholder="{{ placeholder|trans }}">
            <span class="input-group-btn">
                <button class="btn btn-default" type="submit">
                    {{ 'search.button'|trans }}
                </button>
            </span>
        </div>
    </form>

    <script>
        var search = document.getElementById('search');
        var searchIcon = document.getElementById('search-icon');
        var clearIcon = document.getElementById('clear-icon');
        var searchForm = document.getElementById('search-form');

        function showLoading() {
            searchIcon.className = searchIcon.className.replace(/\bfa-search\b/,'fa-cog fa-spin');
        }
        function hideLoading() {
            searchIcon.className = searchIcon.className.replace(/\bfa-cog fa-spin\b/,'fa-search');
        }

        function showReset() {
            searchIcon.style.display = 'none';
            clearIcon.style.display = 'inline-block';
        }

        function hideReset() {
            searchIcon.style.display = 'inline-block';
            clearIcon.style.display = 'none';
        }
    </script>

{% endmacro %}

{% macro javascript(path, searchSection) %}
    <script>
        var last = '';
        var runningAjax;

        var doSearch = function() {

            var query = last = search.value;
            sessionStorage.setItem('query-{{ searchSection }}', query);
            var path = "{{ path }}?query=" + encodeURIComponent(query);

            if (runningAjax) runningAjax.abort();

            var xmlhttp = new XMLHttpRequest();
            runningAjax = xmlhttp;

            xmlhttp.onreadystatechange = function()
            {
                if (xmlhttp.readyState === 4 && xmlhttp.status === 200)
                {
                    document.getElementById("result").innerHTML=xmlhttp.responseText;
                    window.history.pushState(query, "Search", path);
                    enrichPage();
                }
                hideLoading();
                if (search.value.length >= 3) {
                    showReset();
                }
            };

            xmlhttp.open("GET", path + '&ajax=true', true);
            xmlhttp.setRequestHeader("X-Requested-With", "XMLHttpRequest");
            xmlhttp.send();
        };

        var interval;
        var runSearch = function() {
            hideReset();
            showLoading();
            clearInterval(interval);
            interval = setInterval(function () {
                clearInterval(interval);
                doSearch();
            }, 300);
        };

        if (search.value.length >= 3) {
            console.log("omg");
            showReset();
        }

        clearIcon.onclick = resetSearch;

        function resetSearch() {
            search.value = '';
            hideReset();
            doSearch();
            search.focus();
        }

        search.select();
        search.onkeyup = function(e) {
            if (e.key === 'Escape') return resetSearch();
            if (e.key === 'Enter') return runSearch();
            if(last === search.value) {
                hideLoading();
                if (search.value.length < 3) {
                    showReset();
                }
                return;
            }
            runSearch();
        };

        searchForm.onsubmit = function(e) {
            e.preventDefault();
            runSearch();
        };

        window.onpopstate = function(event) {
            if(event && event.state) {
                location.reload();
            }
        };

        if (search.value.length === 0) {
            search.value = sessionStorage.getItem('query-{{ searchSection }}');
            if (search.value.length !== 0) {
                hideReset();
                showLoading();
                doSearch();
            }
        }
    </script>
{% endmacro %}
